#include <SPI.h>
#include <FTRGBLED.h>

#define outputA 6
#define outputB 7

// Pins the RGBLED module are connected to
const int PIN_CKI = 2;
const int PIN_SDI = 3;
const int swPin= 4 ;//the sw pin attach to pin 4

int counter = 0; 
int aState;
int aLastState;  

int selectedColour = 1; 

int R = 50; 
int G = 100; 
int B = 150;

RGBLEDChain led(1, PIN_CKI, PIN_SDI);

 void setup() { 
   pinMode (outputA,INPUT);
   pinMode (outputB,INPUT);
   led.begin();
   Serial.begin (9600);
   // Reads the initial state of the outputA
   aLastState = digitalRead(outputA);   
   pinMode(swPin, INPUT);
  digitalWrite(swPin, HIGH);
 } 

 void loop() { 
   aState = digitalRead(outputA); // Reads the "current" state of the outputA
   
   // If the previous and the current state of the outputA are different, that means a Pulse has occured
   if(digitalRead(swPin) == LOW)//if button pull down
  {
    Serial.println("button push");
    
    switch (selectedColour) {
    case 1:    
      selectedColour = 2;
      Serial.println("now green");
      break;
    case 2:    
      Serial.println("now blue");
      selectedColour = 3;
      break;
    case 3: 
      Serial.println("now red");
      selectedColour = 1;
      break;
    
    }
    delay(500);
  }
   
   if (aState != aLastState){     
     // If the outputB state is different to the outputA state, that means the encoder is rotating clockwise
     if (digitalRead(outputB) != aState) { 
       counter ++;
        switch (selectedColour) {
          case 1:    
          if(R < 255){
             R ++;
            }
            break;
          case 2:
          if(G < 255){    
            G ++;
          }
            break;
          case 3:
          if(B < 255){ 
            B ++;
            }
            break;
          }       
     } 
     else {
       counter --;
      if(selectedColour > 0){
        switch (selectedColour) {
          case 1:
          if(R > 1){    
             R --;
            }
            break;
          case 2:
          if(G > 1){     
            G --;
          }
            break;
          case 3: 
          if(B > 1){ 
            B --;
          }
            break;
        }
       }
     }
     Serial.print(R);
     Serial.print(",");
     Serial.print(G);
     Serial.print(",");
     Serial.println(B);
   } 
   
   updateLED(R,G,B);
   
   aLastState = aState; // Updates the previous state of the outputA with the current state
 }

void updateLED(int R, int G, int B){
  led.setLED(0, R, G, B);
  led.update();  
  
  }

 
